#include "testlib.h"
#include <bits/stdc++.h>

using namespace std;

const int MIN_N = 1;
const int MAX_N = 1000;

const int rnd_test_n = 100;

template <typename T> void append(vector<T> &dest, const vector<T> &orig) {
	dest.insert(dest.end(), orig.begin(), orig.end());
}

string output_tc(const string &x, const string &y) {
	ostringstream oss;
    oss << x.size() << " " << y.size() << endl;
    oss << x << " " << y << endl;
	return oss.str();
}

vector<string> generate_sample_tests() {
	vector<string> tests;
    tests.push_back(output_tc("abcde", "ace"));
    tests.push_back(output_tc("abc", "abc"));
    tests.push_back(output_tc("abc", "hhh"));
	return tests;
}

vector<string> generate_manual_tests() {
	vector<string> tests;
	return tests;
}

string rnd_test(int i){
    int min_n = MIN_N;
    int max_n = MAX_N;
    
    if(i<rnd_test_n / 3){
        max_n = 5;
    }
    else if(i<rnd_test_n / 2){
        max_n = 20;
    }
    int size1 = rnd.next(min_n, max_n);
    string x = rnd.next("[a-z]{" + to_string(size1) + "}");
    int size2 = rnd.next(min_n, max_n);
    string y = rnd.next("[a-z]{" + to_string(size2) + "}");
    return(output_tc(x, y));
}

vector<string> generate_random_tests() { 
    vector<string> tests;
    for (int i = 0; i < rnd_test_n; i++){
        tests.push_back(rnd_test(i));
    } 
    return tests;
}

string extreme_test_1(){
    return(output_tc(rnd.next("[a-z]{1000}"), rnd.next("[a-z]{1000}")));
}

vector<string> generate_extreme_tests(){
    vector<string> tests;   
    tests.push_back(extreme_test_1());
    return tests;
}

int main(int argc, char *argv[]) {
	registerGen(argc, argv, 1);
	vector<string> tests;
	size_t test = 0;
	append(tests, generate_sample_tests());
	append(tests, generate_manual_tests());
	append(tests, generate_random_tests());
	append(tests, generate_extreme_tests());
	for (const auto &t : tests) {
		startTest(++test);
		cout << t;
	}
	return 0;
}